set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__EMPL_POST_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__EMPL_POST_SMETA_KS] (
	[LINK_NEW] INT ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__EMPL_POST_SMETA_KS]

GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].POST'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].POST DROP COLUMN LINK_OLD
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].POST ADD LINK_OLD INT NULL
GO


--   
INSERT INTO [{Variable_TempDb}].dbo.__EMPL_POST_SMETA_KS ([LINK_NEW],[LINK_OLD]) 
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = D.LINK
FROM 
	(	SELECT P.LINK, P.NAME {WORK_COLLATE} AS NAME
		FROM {Variable_SmetaDb}.dbo.POST p
		WHERE EXISTS (SELECT * FROM {Variable_SmetaDb}.dbo.STAFF s WHERE P.LINK = S.POST_LINK)
	) d
	INNER JOIN (
		SELECT LINK, [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY [NAME])
		FROM [{Variable_WorkDb}].[dbo].POST P 
		WHERE LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.[NAME],254)
GO
--    
INSERT INTO [{Variable_WorkDb}].[dbo].POST
(CODE, [NAME], LINK_DEP, [LINK_OLD])
    OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
    INTO [{Variable_TempDb}].dbo.__EMPL_POST_SMETA_KS
SELECT distinct
	CODE        = RIGHT(LTRIM(RTRIM(p.CODE)),6), 
	[NAME]      = LTRIM(RTRIM(p.NAME)), 
	LINK_DEP    = {LINK_DEP_MAIN}, 
	[LINK_OLD]  = p.LINK
FROM
	{Variable_SmetaDb}.dbo.POST p
WHERE 
	EXISTS (SELECT * FROM {Variable_SmetaDb}.dbo.STAFF s WHERE P.LINK = S.POST_LINK)	 
	AND
	NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.__EMPL_POST_SMETA_KS T WHERE T.[LINK_OLD] = p.[LINK] )

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].POST DROP COLUMN [LINK_OLD]
GO
COMMIT TRAN

