USE {Variable_TempDb}
GO
--   SUBDIV_HEAD      
IF not exists(select * from sysobjects where id = object_id('[dbo].[__SUBDIV_HEAD_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__SUBDIV_HEAD_SMETA_KS] (
	LINK_NEW INT,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__SUBDIV_HEAD_SMETA_KS]

GO


IF not exists(select * from sysobjects where id = object_id('[dbo].[__SUBDIV_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__SUBDIV_SMETA_KS] (
	LINK_NEW INT,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__SUBDIV_SMETA_KS]

GO


set xact_abort on
BEGIN TRAN


DECLARE @iLINK_UP INT, @iLINK_DEP INT, @iLINK_UP_NEW INT

DECLARE SUBDIV_CURSOR CURSOR FAST_FORWARD
FOR SELECT DISTINCT LINK_UP, dsks.LINK_NEW FROM {Variable_SmetaDb}.dbo.SUBDIV s
INNER JOIN {Variable_SmetaDb}.dbo.SUBDIV_HEAD sh ON sh.LINK = s.LINK_UP
INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = sh.DEP_LINK 

OPEN SUBDIV_CURSOR
FETCH NEXT FROM SUBDIV_CURSOR INTO @iLINK_UP, @iLINK_DEP

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @iLINK_UP_NEW = NULL
	EXEC [{Variable_WorkDb}].dbo.U_SAVE_SUBDIV_HEAD @iLINK_UP_NEW OUTPUT, @iLINK_DEP --LINK_DEP
	
	INSERT INTO [{Variable_TempDb}].dbo.[__SUBDIV_HEAD_SMETA_KS]
	VALUES (@iLINK_UP_NEW, @iLINK_UP)
	
FETCH NEXT FROM SUBDIV_CURSOR INTO @iLINK_UP, @iLINK_DEP
END

CLOSE SUBDIV_CURSOR
DEALLOCATE SUBDIV_CURSOR

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].SUBDIV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].SUBDIV DROP COLUMN LINK_OLD
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].SUBDIV ADD LINK_OLD INT NULL
GO

	INSERT INTO [{Variable_WorkDb}].dbo.[SUBDIV]
	(LINK_UP, CODE, [NAME], LINK_SELF, ORDERS, LIM, DATE_BEGIN, DATE_END, OBOSOB, O_OKATO, O_KPP, LINK_OLD)
	    OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
	    INTO [{Variable_TempDb}].dbo.[__SUBDIV_SMETA_KS]
	SELECT DISTINCT
	   LINK_UP     = shsks1.LINK_NEW,
	   CODE        = LTRIM(RTRIM(s.CODE)),
	   [NAME]      = LTRIM(RTRIM(s.NAME)),
	   LINK_SELF   = shsks2.LINK_NEW,
	   ORDERS      = S.ORDERS,
	   LIM         = S.LIM,
	   s.DATE_BEGIN,
	   S.DATE_END, 
	   S.OBOSOB, 
	   S.O_OKATO, 
	   S.O_KPP,
	   LINK_OLD    = s.LINK
	FROM {Variable_SmetaDb}.dbo.SUBDIV s
	INNER JOIN [{Variable_TempDb}].dbo.[__SUBDIV_HEAD_SMETA_KS] shsks1 ON shsks1.LINK_OLD = s.LINK_UP
	LEFT JOIN [{Variable_TempDb}].dbo.[__SUBDIV_HEAD_SMETA_KS] shsks2 ON shsks2.LINK_OLD = s.LINK_SELF
	
UPDATE [{Variable_WorkDb}].dbo.SUBDIV SET DATE_END = NULL WHERE YEAR(DATE_END) = 9999

--      
DECLARE @iROWCOUNT INT
SELECT @iROWCOUNT = COUNT(1) 
FROM {Variable_SmetaDb}.dbo.SUBDIV
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].SUBDIV DROP COLUMN [LINK_OLD]
GO


COMMIT TRAN
