-- 03. -
SET XACT_ABORT ON
BEGIN TRAN

/*
{Variable_TempDb} =	{Variable_TempDb}
{Variable_WorkDb} =	{Variable_WorkDb}
{Variable_SmetaDb} =	{Variable_SmetaDb}
{LINK_DEP_MAIN}	= 296172
*/
--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEP_PARENT_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__DEP_PARENT_SMETA_KS]
		(
		[LINK_NEW] INT,
		[LINK_OLD] INT
		)
GO

DELETE T1
FROM [dbo].[__DEP_PARENT_SMETA_KS] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].DEPARTMENTS TTT
	WHERE TTT.LINK = T1.LINK_NEW
	)
GO

INSERT INTO [dbo].[__DEP_PARENT_SMETA_KS]
	(
	[LINK_NEW],
	[LINK_OLD]
	)
SELECT
	DEP.LINK,
	T1.PERSON_LINK
FROM
	(
	SELECT 
		D1.PERSON_LINK
	FROM {Variable_SmetaDb}.dbo.RP_RODITELY D1
	GROUP BY
		D1.PERSON_LINK
	) AS T1
INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS PE1_DEP ON (PE1_DEP.PERS_LINK = T1.PERSON_LINK)
INNER JOIN dbo.__DEPARTMENTS_SMETA_KS T2 ON (T2.LINK_OLD = PE1_DEP.LINK)
INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS DEP ON (DEP.LINK = T2.LINK_NEW)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM [dbo].[__DEP_PARENT_SMETA_KS] TTT
	WHERE TTT.LINK_OLD = T1.PERSON_LINK
	)

GO


USE {Variable_WorkDb}
GO

-- 1.      --
-- dbo.DEPARTMENT_GROUPS_REF --
INSERT INTO dbo.DEPARTMENT_GROUPS_REF
	(
	DEP_LINK,
	GROUP_LINK
	)
SELECT
	DEP.LINK,
	DEP_GR.LINK
FROM {Variable_TempDb}.[dbo].[__DEP_PARENT_SMETA_KS] T1
INNER JOIN dbo.DEPARTMENTS DEP ON (DEP.LINK = T1.LINK_NEW)
INNER JOIN dbo.DEPARTMENT_GROUPS DEP_GR ON
	(
	DEP_GR.LINK_DEP = dbo.GetOwnDepLink ()
	AND
		(
		DEP_GR.[SYS] = 4
		OR DEP_GR.[SYS] = 16
		)
	)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.DEPARTMENT_GROUPS_REF TTT
	WHERE TTT.DEP_LINK = DEP.LINK
		AND TTT.GROUP_LINK = DEP_GR.LINK
	)

GO

COMMIT TRAN

